// MPSView.cpp : implementation of the CMPSView class
//

#include "stdafx.h"
#include "MPS.h"

#include "MPSDoc.h"
#include "MPSView.h"

#include <math.h>
double x(double r, double theta);
double y(double r, double theta);




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMPSView

IMPLEMENT_DYNCREATE(CMPSView, CView)

BEGIN_MESSAGE_MAP(CMPSView, CView)
	//{{AFX_MSG_MAP(CMPSView)
	ON_COMMAND(IDM_PLAY_CURVE2, OnPlayCurve2)
	ON_COMMAND(IDM_PLAY_CURVE1, OnPlayCurve1)
	ON_COMMAND(IDM_PLAY_PENDULUM, OnPlayPendulum)
	ON_COMMAND(IDM_PLAY_2DGRID, OnPlay2dgrid)
	ON_COMMAND(IDM_PLAY_2DVIEW, OnPlay2dview)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(IDM_DATA_SAVE, OnDataSave)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPSView construction/destruction

CMPSView::CMPSView()
{
	// TODO: add construction code here

}

CMPSView::~CMPSView()
{
}

BOOL CMPSView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMPSView drawing

void CMPSView::OnDraw(CDC* pDC)
{
	CMPSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMPSView printing

BOOL CMPSView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMPSView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMPSView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMPSView diagnostics

#ifdef _DEBUG
void CMPSView::AssertValid() const
{
	CView::AssertValid();
}

void CMPSView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMPSDoc* CMPSView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMPSDoc)));
	return (CMPSDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMPSView message handlers


void CMPSView::OnPlayCurve2() 
{
	// TODO: Add your command handler code here
	double x, xx, y, yy;

	CRect rect;
	GetClientRect(&rect);
	
	CClientDC dc(this);
	//dc.SetMapMode(MM_LOMETRIC);
	dc.SetViewportOrg(rect.Width()/2, rect.Height()/2);

	//dc.MoveTo(-rect.Width(), 0);
	//dc.LineTo(rect.Width(), 0);
	//dc.MoveTo(0, -rect.Height());
	//dc.LineTo(0, rect.Height());

	dc.MoveTo(-800, 0);
	dc.LineTo(800, 0);
	dc.MoveTo(0, -450);
	dc.LineTo(0, 450);



	for(x= -1500; x< 1500; x+= 0.01)
	{
		xx= x/300;
		y= cos(xx) - xx;
		yy= 150*y;
		dc.SetPixel(int(x), int(yy), RGB(255,0,255));
	}
	

}




void CMPSView::OnPlayCurve1() 
{
	// TODO: Add your command handler code here
	//double x, xx, y, yy;

	CRect rect;
	GetClientRect(&rect);
	
	CClientDC dc(this);
	dc.SetMapMode(MM_LOMETRIC);
	dc.SetViewportOrg(rect.Width()/2, rect.Height()/2);





	//dc.MoveTo(-rect.Width(), 0);
	//dc.LineTo(rect.Width()/2, 0);
	//dc.MoveTo(0, -800);
	//dc.LineTo(0, 1200);

	dc.MoveTo(-500, 0);
	dc.LineTo(1500, 0);
	dc.MoveTo(0, -1000);
	dc.LineTo(0, 1000);





	const double pi= 3.14;
	double theta, r, mag= 900, a= 0.5, b= 1.0;

	for(theta= 0; theta< 2*pi; theta+= pi/55000)
	{
		r= mag*(a + b*cos(theta));

		dc.SetPixel(int(x(r,theta)), int(y(r,theta)), RGB(255,0,255));


	}	


}




double CMPSView::x(double r, double theta)
{
	return r*cos(theta);
}

double CMPSView::y(double r, double theta)
{
	return r*sin(theta);
}

void CMPSView::OnPlayPendulum() 
{
	// TODO: Add your command handler code here

	CClientDC dc(this);
	//CPaintDC dc(this);

	int x0= 200, y0= 10, xLength= 300, yLength= 300;
	dc.Rectangle(x0, y0, x0 + xLength, y0 + yLength);

	double pi, omega, theta, t;
	double m_g, m_L, m_T, m_Theta0, m_timeToStop;
	double m_xLow, m_xHigh, m_yHigh, m_yLow;
	
	pi= 4.*atan(1.);
	m_g= 9.8; // gravitational accelator
	m_L= 3; // length
	m_Theta0= 30;
	m_timeToStop= 10;
	m_xLow=-2.5;
	m_xHigh= 2.5;
	m_yLow= 5;
	m_yHigh= 0;


	omega= sqrt(m_g/m_L);
	m_T= 2*pi/omega;
	
	int xwin, ywin;

	xwin= int( (m_L*sin(m_Theta0/180.*pi) - m_xLow)*xLength/(m_xHigh - m_xLow) + x0);
	ywin= int( m_L*cos(m_Theta0/180.*pi)*yLength/m_yLow + y0);


	dc.MoveTo(x0 + xLength/2, y0);
	dc.LineTo(xwin, ywin);
	dc.Ellipse(xwin-15, ywin-15, xwin+15, ywin+15);


	for(t= 0; t<= m_timeToStop; t+= 0.05)
	{


		Sleep(50);
		dc.Rectangle(x0, y0, x0+xLength, y0+yLength);
		theta= m_Theta0*cos(omega*t)/180.*pi;
		xwin= int( (m_L*sin(theta) - m_xLow)*xLength/(m_xHigh - m_xLow) + x0);
		ywin= int( m_L*cos(theta)*yLength/m_yLow + y0);

		dc.MoveTo(x0+xLength/2, y0);
		dc.LineTo(xwin, ywin);
		dc.Ellipse(xwin-15, ywin-15, xwin+15, ywin+15);
	}







}




void CMPSView::OnPlay2dview() 
{
	// TODO: Add your command handler code here
	CRect rect;
	GetClientRect(&rect);
	
	CClientDC dc(this);
	dc.SetMapMode(MM_TEXT);
	//dc.SetMapMode(MM_LOMETRIC);
	dc.SetViewportOrg(rect.Width()/2, rect.Height()/2);



	dc.MoveTo(-800, 0);
	dc.LineTo(800, 0);
	dc.MoveTo(0, -450);
	dc.LineTo(0, 450);



	int cn; 
	FILE *fp;

	fp= fopen("2dview.txt", "r");
	if(fp == NULL){
		::AfxMessageBox(_T("data2.txt file is not opended"));
		//exit(1);
	}

	//int m_xPos, m_yPos;
	double m_xPos, m_yPos;
	int xPos, yPos;



	int timeLoop=0;

	while(!feof(fp)){
	for(int i= 0; i<=1122; i++){

		
		cn= fscanf(fp, "%lf%lf", &m_xPos, &m_yPos);
		if(cn == 0){
		::AfxMessageBox(_T("Error: can't get data."));
		printf("%d\n",m_xPos);
	}


	// draw the origin	
	dc.MoveTo(-800, 0);
	dc.LineTo(800, 0);
	dc.MoveTo(0, -450);
	dc.LineTo(0, 450);	
	
	// draw the box
	int x0= -30, y0= 18, xLength= 30, yLength= -200;
	//dc.Rectangle(x0, y0, x0 + xLength, y0 + yLength);
	//dc.Rectangle(x0+200, y0, x0 + xLength, y0 + yLength);


		xPos= int(m_xPos*1600/1.6);
		yPos= -int(m_yPos*900/1.6);
		dc.Ellipse(xPos-5, yPos-5, xPos+5, yPos+5);

	}	



	//Invalidate(TRUE);
	Sleep(10);
	dc.SelectStockObject(WHITE_BRUSH);
	int xCenterScreen= rect.Width()/2;
	int yCenterScreen= rect.Height()/2;
	int ellipseRadius= rect.Width()*2;







	if(timeLoop < 100){
		timeLoop++;
		dc.Ellipse(xCenterScreen-ellipseRadius, yCenterScreen-ellipseRadius,xCenterScreen+ellipseRadius, yCenterScreen+ellipseRadius);
	}



	}












	fclose(fp);
}








void CMPSView::OnPlay2dgrid() 
{
	// TODO: Add your command handler code here
	CRect rect;
	GetClientRect(&rect);
	
	CClientDC dc(this);
	dc.SetMapMode(MM_TEXT);
	//dc.SetMapMode(MM_LOMETRIC);
	dc.SetViewportOrg(rect.Width()/2, rect.Height()/2);



	dc.MoveTo(-800, 0);
	dc.LineTo(800, 0);
	dc.MoveTo(0, -450);
	dc.LineTo(0, 450);



	int cn; 
	FILE *fp;

	fp= fopen("data.txt", "r");
	if(fp == NULL){
		::AfxMessageBox(_T("data2.txt file is not opended"));
		//exit(1);
	}

	//int m_xPos, m_yPos;
	double m_xPos, m_yPos;
	int xPos, yPos;


	while(!feof(fp)){
		cn= fscanf(fp, "%lf%lf", &m_xPos, &m_yPos);
		if(cn == 0){
		::AfxMessageBox(_T("Error: can't get data."));
		printf("%d\n",m_xPos);
	}


		xPos= int(m_xPos*1600/1.6);
		yPos= -int(m_yPos*900/1.6);

		dc.Ellipse(xPos-5, yPos-5, xPos+5, yPos+5);


	}	
	
	fclose(fp);

}

void CMPSView::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	FILE *fp;
	fp= fopen("test.txt","wt");

	int a[10]= {174, 175, 165, 160, 178, 155, 158, 180, 154, 163};

	int i, n;

	double sum, mean;

	n= sizeof(a)/sizeof(int);

	fprintf(fp, "Data are as follows:\n");

	sum= 0;
	for(i= 0; i< n; i++){
		sum= sum + a[i];
		fprintf(fp, "%-5d", a[i]);
	}

	mean= sum/n;
	fprintf(fp, "\nmean= %lf\n", mean);
	fclose(fp);

	AfxMessageBox("test.txt");


}

void CMPSView::OnDataSave() 
{
	// TODO: Add your command handler code here
	CFile file;

	char *pFileName= "Test_datasave.txt";
	char *lpBuf= "Congratulations, You're welcome";

	file.Open(pFileName, CFile::modeCreate|CFile::modeWrite);
	file.Write(lpBuf, 50);
	file.Close();




	CFile fileRead;
	char *lpBufRead= new char[100];
	fileRead.Open(pFileName, CFile::modeRead);
	fileRead.Read(lpBufRead, 50);

	fileRead.Close();

	CClientDC dc(this);
	dc.TextOut(100, 100, lpBufRead, lstrlen(lpBufRead));


}
