// MPSView.h : interface of the CMPSView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MPSVIEW_H__32D092AF_B1D1_4D7F_A057_61A22394131D__INCLUDED_)
#define AFX_MPSVIEW_H__32D092AF_B1D1_4D7F_A057_61A22394131D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMPSView : public CView
{
protected: // create from serialization only
	CMPSView();
	DECLARE_DYNCREATE(CMPSView)

// Attributes
public:
	CMPSDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMPSView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_yPos;
	int m_xPos;
	double y(double r, double theta);
	double x(double r, double theta);
	virtual ~CMPSView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMPSView)
	afx_msg void OnPlayStart();
	afx_msg void OnPlayCurve2();
	afx_msg void OnPlayCurve1();
	afx_msg void OnPlayPendulum();
	afx_msg void OnPlay2dgrid();
	afx_msg void OnPlay2dview();
	afx_msg void OnFileSaveAs();
	afx_msg void OnDataSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MPSView.cpp
inline CMPSDoc* CMPSView::GetDocument()
   { return (CMPSDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MPSVIEW_H__32D092AF_B1D1_4D7F_A057_61A22394131D__INCLUDED_)
